"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AmqpQueuePublisherManager = void 0;
const core_1 = require("@message-queue-toolkit/core");
const CommonAmqpPublisherFactory_1 = require("./CommonAmqpPublisherFactory");
class AmqpQueuePublisherManager extends core_1.AbstractPublisherManager {
    constructor(dependencies, options) {
        super({
            isAsync: false,
            eventRegistry: dependencies.eventRegistry,
            metadataField: options.metadataField ?? 'metadata',
            metadataFiller: options.metadataFiller,
            newPublisherOptions: options.newPublisherOptions,
            publisherDependencies: {
                amqpConnectionManager: dependencies.amqpConnectionManager,
                logger: dependencies.logger,
                errorReporter: dependencies.errorReporter,
            },
            publisherFactory: options.publisherFactory ?? new CommonAmqpPublisherFactory_1.CommonAmqpQueuePublisherFactory(),
        });
    }
    resolveCreationConfig(queueName) {
        return {
            ...this.newPublisherOptions,
            queueOptions: {},
            queueName,
        };
    }
    publish(queue, message, precedingEventMetadata, messageOptions) {
        // Purpose of this override is to provide better name for the first argument
        // For AMQP Queues it is going to be queue
        return super.publish(queue, message, precedingEventMetadata, messageOptions);
    }
    resolveEventTarget(event) {
        return event.queueName;
    }
}
exports.AmqpQueuePublisherManager = AmqpQueuePublisherManager;
//# sourceMappingURL=AmqpQueuePublisherManager.js.map